﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    // custome file structure for Assist

    public class Structure
    {
        // Region for all USA structure

        #region usaFile

        //USA main format structure
        public struct usaFile
        {
            public char[] header; // usa header
            public UInt64 fileSize; // file size
            public UInt64 version; // vrsion
            public string userName; // user nam of the person
            public string step; // step of the model
            public string comments; // cooments about file
            public geometry[] geometries; // geometry of the 3D model
            public apearance[] apearances; // aparance of the 3D model
            public scene Scene; // scene of the 3D model
            public animation[] animations; // animation of the 3D model 
        }

        // Encording geometry of the 3D model
        public struct geometry
        {
            public UInt16 serfaceID; // ID of the each triangle serface
            public UIntPtr point1; // first vertx of the triangle
            public UIntPtr point2; // second vertex of the triangle
            public UIntPtr point3; // third vertex of the triangle
            public UIntPtr nPoint1; // first vertex of the outword normal vector
            public UIntPtr nPoint2; // second vertex of the outword normal vector
        }

        // storing apearance of the 3D model
        public struct apearance
        {
            public UInt16 serfaceID2; //ID of the each serface
            public UInt32 aColor; // colour of the ech serface
            public UInt64 texture; // texture of the serface
            public UInt32 matirial; // material of ther serface
        }

        //saving scene informtion
        public struct scene
        {
            public camera cam;
            public light lightSource;
        }

        // camra information
        public struct camera
        {
            public UIntPtr magPoint; // magnification point of the camera
            public UIntPtr location; // Location of the camra
            public UIntPtr direction; // direction of thee camera
            public bool up; //which dirction is the up 
        }

        //light source information
        public struct light
        {
            public UIntPtr lLoction; // direction of the light source
            public UInt32 lColour; // colour of the source light
            public UInt32 intensity; // intencity of the light source
        }

        //Encording Animation
        public struct animation
        {
            public float rotation; // rotation of the virtual bone
            public float scale; // scale of the bone
            public UIntPtr shear; // shear of the bone
            public UIntPtr translation; // translation of th bone
        }

        #endregion

    }
}
